#!/bin/bash
# on attend 2 arguments. Plus simple à mettre en ligne de commande, avec l'auto-complétion, si il y a par exemple des espaces dans l'arborescence de la destination
if [ $# -eq 2 ]
then
	fichier=$1
	destination=$2
	premiercard=$(echo "$destination" | cut -c1)
       	if [ "$premiercard" != "/" ]
	then
		echo "Il faut mettre la destination en chemin absolu"	
	else
		total=0 # taille totale des fichiers à copier
		stop=0  # phase 1/2 :marqueur d'arrêt si répertoire lu != celui empilmé dans le tableau, pour trouver la racine ...
			# phase 3 :...mais aussi marqueur de départ, puisque correspondant à la case du tableau ayant le nom du répertoire racine
		# ====== phase 1 & 2 en même temps : voir la taille requise/dispo + trouver racine
		# note : si on utilise cat, un sous-shell est créé et la variable total sera a zéro en sortie de boucle
		if [ -f "$fichier" -a -r "$fichier" ]
		then
			echo "Lecture du fichier playlist"
			while read ligne
			do
				# si ligne commence par # on ignore
				premiercar=$(echo "$ligne" | cut -c1)
				if [ "$premiercar" != "#" ] 
				then
					# === récupération de la taille du fichier en Ko
					taille=$(du -k "$ligne" | awk '{ print $1 }')
					total=$(($total + $taille))
					# === découpage et empilage des répertoires dans un tableau, jusqu'à ce que répertoire != case correspondante, et on indique le numéro de case
					# NF est le nombre de champs
					nchamp=$(echo "$ligne" | awk -F / '{ print NF }')
					if [ $stop -eq 0 ]
					then
						stop=$nchamp
					fi
					if [ "$premiercar" == "/" ]
					then
						i=2 # premier champ nul, car on débute par la racine, / (normalement) --> ajouter if premiercar = / ? 
						j=2
					else
						i=1
						j=1
					fi
					while [ $i -le $nchamp  -a $i -le $stop ]
					do
						chaine=$(echo "$ligne" | awk -F / '{ print $'$i' }')
						if [ "$chaine" != "${arborescence[$i]}" ] 
						then
							if [ "${arborescence[$i]}" != "" ]
							then
								stop=$(expr $i - 1)
							else
								arborescence[$i]="$chaine"
							fi
						fi
						i=$(expr $i + 1)
					done
				fi
			done < $fichier
			# j initialisé en même temps que i, dans la boucle while précédente
			racine=""
			while [ $j -le $stop ]
			do
				racine="$racine""/""${arborescence[$j]}"
				j=$(expr $j + 1)
			done 
			echo "Racine trouvée : $racine"
			echo "Taille totale requise : $total Ko"
			if [ -d "$destination" ] 
			then
				dispo=$(df -k $destination | tail -n 1 | awk '{ print $4 }')
				echo "Taille libre sur $destination : $dispo Ko"
				if [ $dispo -gt $total ]
				then
					echo "Il y a assez de place sur $destination"
					if [ -w "$destination" ]
					then
						# ====== phase 3 : copie
						echo "Copie des fichiers..."
						#  on re-lit une deuxième fois le fichier playlist
						while read ligne
						do
							 # si ligne commence par # on ignore
 							premiercar=$(echo "$ligne" | cut -c1)
        	                			if [ "$premiercar" != "#" ]
        	                			then
								nchamp=$(echo "$ligne" | awk -F / '{ print NF }')
								fin=$(expr $nchamp - 1)
								k=$(expr $stop + 1) # pour copier racine/dossier1/ssdossier1.....
								dossier="${arborescence[$stop]}"
								while [ $k -le $fin ]
								do
									chaine=$(echo "$ligne" | awk -F / '{ print $'$k' }')
									dossier="$dossier""/""$chaine"
									k=$(expr $k + 1)
								done
								musique=$(echo "$ligne" | awk -F / '{ print $'$nchamp' }')
								# si derniercar de destination = /, alors on ne le met pas ici
								ncar=$(echo "$destination" | wc -m)
								lcar=$(expr $ncar - 1)
								derniercar=$(echo "$destination" | cut -c$lcar)
								if [ "$derniercar" != "/" ]
								then
									$(mkdir -p "$destination""/""$dossier")
									$(cp "$ligne" "$destination""/""$dossier""/""$musique")
								else
									$(mkdir -p "$destination""$dossier")
									$(cp "$ligne" "$destination""$dossier""/""$musique")
								fi
							fi
						done < $fichier
						echo "Copie terminée !"
					else
						echo "Pas d'accès en écriture sur $destination"
					fi
				else
					echo "Il n'y a pas assez de place sur $destination"
				fi
			else
				echo "$destination n'est pas un répertoire"
			fi
		else
			echo "$fichier n'est pas un fichier"	
		fi
	fi
else	
	echo "il faut 2 arguments, et non $#"
fi
